
extern char enc_errMsg[256];
extern int enc_errStatus;

typedef struct 
{	void *(*create)(char *key);
	void (*destroy)(void *encObj);
	void (*encBuf)(void *encObj, unsigned char *buf);
	void (*decBuf)(void *encObj, unsigned char *buf);
	int encNum;
	int bufSize;
} enc_t;

void enc_register(enc_t enc);
void enc_glue(void);

typedef struct eib_s eib_t;
eib_t *eib_open(FILE *fin, int isPosEnc);
void eib_close(eib_t *eib);
int eib_keyInit(eib_t *eib, char *key);
int eib_whichEnc(eib_t *eib);
int eib_getc(eib_t *eib);

typedef struct eob_s eob_t;
eob_t *eob_open(FILE *fin, int whichEnc, char *key);
void eob_close(eob_t *eob);
int eob_putc(eob_t *eob, int ch);
int eob_fwrite(eob_t *eob, char *data, int data_len);



