#ifndef GZIP_H
#define GZIP_H 1


//==============================  gzipPush =================================

typedef struct gzipPush_t gzipPush_t;


// Constructor.
gzipPush_t *gzipPush_new
(
	void (*putChar)(void *outStream, unsigned char ch)
		// Used to send one char onto the next thing.  E.g. May well just
		// call putchar().

,	void *outStream  // Whatever putChar() needs as its first argument.

,	int isDecompress  // If true, we decompress, else we compress.

);


// Send one char to gzip to be compressed or decompressed.
void gzipPush_outCh(gzipPush_t *gz, unsigned char ch);


// Free resources.
void gzipPush_free(gzipPush_t *gz);



//==============================  gzipPull =================================

typedef struct gzipPull_t gzipPull_t;


gzipPull_t *gzipPull_new(int (*getCh)(void *inStream), void *inStream, int isDecompress);


void gzipPull_free(gzipPull_t *gp);


int gzipPull_getc(gzipPull_t *gp);


#endif

