
#define ROT_SIZE 32		/* Must be 2^n for some n. */

typedef struct rota_s rota_t;

// Constructor.
rota_t *rota_create(unsigned char *key);

// Destructor.
void rota_destroy(rota_t *rota);

/* Restore rota from copy made by constructor. */
void rota_reset(rota_t *rota);

// Returns pointer to a block of (2 * ROT_SIZE) bytes, any part of which
// may be used as a digest of the key that rota was created with.  Note that
// this is a pointer to a block that should not be freed, becuase the
// memory belongs to rota. 
unsigned char* rota_digest(rota_t *rota);


// This function will incorporate chin into rota and return chin masked.
// All characters must be unmasked in the same order that they were masked.
unsigned char rota_mask(rota_t *rota, unsigned char chin);


// This function will incorporate chout into rota and return chout unmasked.
// All characters must be unmasked in the same order that they were masked.
unsigned char rota_unmask(rota_t *rota, unsigned char chout);


